<template>
  <form
    v-bind:method="method == 'GET' ? 'GET' : 'POST'"
    v-bind:action="action"
    v-on:submit.prevent
  >
    <input type="hidden" name="_method" v-bind:value="method" />
    <confirm-dialogue ref="confirmDialogue"></confirm-dialogue>
    <loading-component ref="loadingComponent"></loading-component>
    <slot :onSubmit="onSubmit"></slot>
  </form>
</template>

<script>
import Api from "@/api";

export default {
  props: {
    confirm: Boolean,
    method: String,
    action: String,
  },
  data: function () {
    return {
      is_confirm: this.confirm,
    };
  },
  methods: {
    async onSubmit() {
      if (this.is_confirm) {
        const ok = await this.$refs.confirmDialogue.show({
          title: "Realizar compra",
          message: "Está seguro de realizar la compra?.",
          cancelButton: "Cancelar",
          okButton: "Comprar",
        });

        if (ok) {
          this.send();
        }
      } else {
        this.send();
      }
    },

    async send() {
      this.$refs.loadingComponent.open();
      await Api.onSubmit(this.$el);
      this.$refs.loadingComponent.close();
    },
  },
};
</script>